/*
Copyright (C) 2006 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef STATE_20060715_H_
#define STATE_20060715_H_

#include "types.h"

class QString;

struct State {
public:
	State();
	State(const State &other);

public:
	BaseTypes::reg_t ebx;
	BaseTypes::reg_t ecx;
	BaseTypes::reg_t edx;
	BaseTypes::reg_t esi;
	BaseTypes::reg_t edi;
	BaseTypes::reg_t ebp;
	BaseTypes::reg_t eax;
	BaseTypes::reg_t esp;
	union { BaseTypes::reg_t _cs; uint16_t cs; };
	union { BaseTypes::reg_t _ds; uint16_t ds; };
	union { BaseTypes::reg_t _es; uint16_t es; };
	union { BaseTypes::reg_t _fs; uint16_t fs; };
	union { BaseTypes::reg_t _gs; uint16_t gs; };
	union { BaseTypes::reg_t _ss; uint16_t ss; };
	union { BaseTypes::reg_t eip; uint16_t ip; };
	union { BaseTypes::reg_t eflags; uint16_t flags; };
	BaseTypes::reg_t orig_eax;

public:
	BaseTypes::reg_t value(const QString &reg, bool *ok = 0) const;
	void clear();
	
	enum {		
		// groups, these catagories should remain as portable as possible
		REG_GPR		= 0x0001,
		REG_IP		= 0x0002,
		REG_SEG		= 0x0004,
		REG_COND	= 0x0008,
		REG_FPU		= 0x0010,
		REG_ANY		= -1
	};
};

#endif
