/*
Copyright (C) 2006 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef UTIL_20061126_H_
#define UTIL_20061126_H_

template <typename T>
void safeDelete(T *&ptr) {
	delete ptr;
	ptr = 0;
}

template <typename T>
void safeDeleteArray(T *&ptr) {
	delete [] ptr;
	ptr = 0;
}


/* unsigned ctype = <cctype> functions accept only unsigned char values or 
 * EOF, but "char" is often signed. When passing "char", use 
 * safe_ctype<std::tolower>(c) instead of std::tolower(c), where safe_ctype 
 * is defined as thus: 
 */

template <int (&F) (int)> int safe_ctype (unsigned char c) {
	return F(c);
}

static inline bool setBool(bool *b, bool value) {
	return b != 0 ? *b = value : value;
}

#endif
