
#ifndef RESULTVIEWMODEL_20070419_H_
#define RESULTVIEWMODEL_20070419_H_

#include <QAbstractItemModel>
#include <QVector>
#include "types.h"

struct Result {
	BaseTypes::address_t block;
	BaseTypes::address_t size;
	QString type;
};


class ResultViewModel : public QAbstractItemModel {
	Q_OBJECT
public:
	ResultViewModel(QObject *parent = 0);
	~ResultViewModel();

public:
	virtual QVariant data(const QModelIndex &index, int role) const;
	virtual QModelIndex index(int row, int column, const QModelIndex &parent = QModelIndex()) const;
	virtual QModelIndex parent(const QModelIndex &index) const;
	virtual int rowCount(const QModelIndex &parent = QModelIndex()) const;
	virtual int columnCount(const QModelIndex &parent = QModelIndex()) const;
	virtual QVariant headerData ( int section, Qt::Orientation orientation, int role = Qt::DisplayRole ) const;
	virtual void sort (int column, Qt::SortOrder order = Qt::AscendingOrder);
private:
	static bool blockLess(const Result &s1, const Result &s2) {
		return s1.block < s2.block;
	}

	static bool SizeLess(const Result &s1, const Result &s2) {
		return s1.size < s2.size;
	}

	static bool TypeLess(const Result &s1, const Result &s2) {
		return s1.type < s2.type;
	}

	static bool blockGreater(const Result &s1, const Result &s2) {
		return s1.block > s2.block;
	}

	static bool SizeGreater(const Result &s1, const Result &s2) {
		return s1.size > s2.size;
	}

	static bool TypeGreater(const Result &s1, const Result &s2) {
		return s1.type > s2.type;
	}
public:
	void addResult(const Result &r);
	void clearResults();

private:
	QVector<Result> m_Results;	
};

#endif

