
#ifndef RECENTFILEMANAGER_20070430_H_
#define RECENTFILEMANAGER_20070430_H_

#include <QStringList>
#include <QString>
#include <QWidget>

class QMenu;
class QWidget;

class RecentFileManager : public QWidget {
	Q_OBJECT
public:
	RecentFileManager(QWidget * parent = 0, Qt::WindowFlags f = 0);
	virtual ~RecentFileManager();

public:
	void addFile(const QString &file);
	QMenu *createMenu();

public slots:
	void clearFileList();
	void itemSelected();
	
signals:
	void fileSelected(const QString &);

private:
	void saveFileList();
	void loadFileList();
	void update();

private:
	static const int MaxRecentFiles = 4;

private:
	QStringList	m_FileList;
	QMenu		*m_Menu;
};

#endif

